Add user and group for the monitoring agent
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/Curl \
68         src/Ganeti/DataCollectors \
69         src/Ganeti/HTools \
70         src/Ganeti/HTools/Backend \
71         src/Ganeti/HTools/Program \
72         src/Ganeti/Hypervisor \
73         src/Ganeti/Hypervisor/Xen \
74         src/Ganeti/Query \
75         test/hs \
76         test/hs/Test \
77         test/hs/Test/Ganeti \
78         test/hs/Test/Ganeti/Block \
79         test/hs/Test/Ganeti/Block/Drbd \
80         test/hs/Test/Ganeti/Confd \
81         test/hs/Test/Ganeti/HTools \
82         test/hs/Test/Ganeti/HTools/Backend \
83         test/hs/Test/Ganeti/Hypervisor \
84         test/hs/Test/Ganeti/Hypervisor/Xen \
85         test/hs/Test/Ganeti/Query
86
87 # Haskell directories without the roots (src, test/hs)
88 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
89
90 DIRS = \
91         $(HS_DIRS) \
92         autotools \
93         daemons \
94         devel \
95         doc \
96         doc/css \
97         doc/examples \
98         doc/examples/gnt-debug \
99         doc/examples/hooks \
100         test/data/htools \
101         test/data/htools/rapi \
102         test/hs/shelltests \
103         lib \
104         lib/build \
105         lib/client \
106         lib/confd \
107         lib/http \
108         lib/hypervisor \
109         lib/impexpd \
110         lib/masterd \
111         lib/rapi \
112         lib/server \
113         lib/tools \
114         lib/utils \
115         lib/watcher \
116         man \
117         qa \
118         test \
119         test/data \
120         test/data/bdev-rbd \
121         test/data/ovfdata \
122         test/data/ovfdata/other \
123         test/py \
124         tools
125
126 ALL_APIDOC_HS_DIRS = \
127         $(APIDOC_HS_DIR) \
128         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
129
130 BUILDTIME_DIR_AUTOCREATE = \
131         scripts \
132         $(APIDOC_DIR) \
133         $(ALL_APIDOC_HS_DIRS) \
134         $(APIDOC_PY_DIR) \
135         $(COVERAGE_DIR) \
136         $(COVERAGE_HS_DIR) \
137         $(COVERAGE_PY_DIR) \
138         .hpc
139
140 BUILDTIME_DIRS = \
141         $(BUILDTIME_DIR_AUTOCREATE) \
142         doc/html \
143         doc/man-html
144
145 DIRCHECK_EXCLUDE = \
146         $(BUILDTIME_DIRS) \
147         ganeti-[0-9]*.[0-9]*.[0-9]* \
148         doc/html/_* \
149         doc/man-html/_* \
150         autom4te.cache
151
152 # some helper vars
153 COVERAGE_DIR = doc/coverage
154 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
155 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
156 APIDOC_DIR = doc/api
157 APIDOC_PY_DIR = $(APIDOC_DIR)/py
158 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
159
160 MAINTAINERCLEANFILES = \
161         $(maninput) \
162         doc/install-quick.rst \
163         doc/news.rst \
164         doc/upgrade.rst \
165         vcs-version
166
167 maintainer-clean-local:
168         rm -rf $(BUILDTIME_DIRS)
169
170 CLEANFILES = \
171         $(addsuffix /*.py[co],$(DIRS)) \
172         $(addsuffix /*.hi,$(HS_DIRS)) \
173         $(addsuffix /*.o,$(HS_DIRS)) \
174         $(PYTHON_BOOTSTRAP) \
175         epydoc.conf \
176         $(REPLACE_VARS_SED) \
177         $(SHELL_ENV_INIT) \
178         daemons/daemon-util \
179         daemons/ganeti-cleaner \
180         $(mandocrst) \
181         doc/manpages-enabled.rst \
182         $(BUILT_EXAMPLES) \
183         doc/examples/bash_completion \
184         doc/examples/bash_completion-debug \
185         lib/_generated_rpc.py \
186         $(man_MANS) \
187         $(manhtml) \
188         tools/kvm-ifup \
189         tools/vcluster-setup \
190         stamp-directories \
191         stamp-srclinks \
192         $(nodist_pkgpython_PYTHON) \
193         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
194         $(HS_BUILT_TEST_HELPERS) \
195         src/ganeti-confd \
196         .hpc/*.mix src/*.tix test/hs/*.tix \
197         doc/hs-lint.html
198
199 GENERATED_FILES = \
200         $(built_base_sources) \
201         $(BUILT_PYTHON_SOURCES) \
202         $(PYTHON_BOOTSTRAP)
203
204 HS_GENERATED_FILES =
205 if WANT_HTOOLS
206 HS_GENERATED_FILES += $(HS_PROGS)
207 if ENABLE_CONFD
208 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
209 endif
210 endif
211
212 built_base_sources = \
213         stamp-directories \
214         stamp-srclinks
215
216 built_python_base_sources = \
217         lib/_autoconf.py \
218         lib/_vcsversion.py
219
220 BUILT_PYTHON_SOURCES = \
221         $(built_python_base_sources) \
222         lib/_generated_rpc.py
223
224 # Generating the RPC wrappers depends on many things, so make sure
225 # it's built at the end of the built sources
226 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
227
228 # these are all built from the underlying %.in sources
229 BUILT_EXAMPLES = \
230         doc/examples/ganeti-kvm-poweroff.initd \
231         doc/examples/ganeti.cron \
232         doc/examples/ganeti.initd \
233         doc/examples/ganeti-master-role.ocf \
234         doc/examples/ganeti-node-role.ocf \
235         doc/examples/gnt-config-backup \
236         doc/examples/hooks/ipsec
237
238 nodist_pkgpython_PYTHON = \
239         $(BUILT_PYTHON_SOURCES)
240
241 noinst_PYTHON = \
242         lib/build/__init__.py \
243         lib/build/shell_example_lexer.py \
244         lib/build/sphinx_ext.py
245
246 pkgpython_PYTHON = \
247         lib/__init__.py \
248         lib/asyncnotifier.py \
249         lib/backend.py \
250         lib/bdev.py \
251         lib/bootstrap.py \
252         lib/cli.py \
253         lib/cmdlib.py \
254         lib/compat.py \
255         lib/config.py \
256         lib/constants.py \
257         lib/daemon.py \
258         lib/errors.py \
259         lib/ht.py \
260         lib/jqueue.py \
261         lib/jstore.py \
262         lib/locking.py \
263         lib/luxi.py \
264         lib/mcpu.py \
265         lib/netutils.py \
266         lib/objects.py \
267         lib/opcodes.py \
268         lib/outils.py \
269         lib/ovf.py \
270         lib/pathutils.py \
271         lib/qlang.py \
272         lib/query.py \
273         lib/rpc.py \
274         lib/rpc_defs.py \
275         lib/runtime.py \
276         lib/serializer.py \
277         lib/ssconf.py \
278         lib/ssh.py \
279         lib/storage.py \
280         lib/uidpool.py \
281         lib/vcluster.py \
282         lib/network.py \
283         lib/workerpool.py
284
285 client_PYTHON = \
286         lib/client/__init__.py \
287         lib/client/gnt_backup.py \
288         lib/client/gnt_cluster.py \
289         lib/client/gnt_debug.py \
290         lib/client/gnt_group.py \
291         lib/client/gnt_instance.py \
292         lib/client/gnt_job.py \
293         lib/client/gnt_node.py \
294         lib/client/gnt_network.py \
295         lib/client/gnt_os.py \
296         lib/client/gnt_storage.py
297
298 hypervisor_PYTHON = \
299         lib/hypervisor/__init__.py \
300         lib/hypervisor/hv_base.py \
301         lib/hypervisor/hv_chroot.py \
302         lib/hypervisor/hv_fake.py \
303         lib/hypervisor/hv_kvm.py \
304         lib/hypervisor/hv_lxc.py \
305         lib/hypervisor/hv_xen.py
306
307 rapi_PYTHON = \
308         lib/rapi/__init__.py \
309         lib/rapi/baserlib.py \
310         lib/rapi/client.py \
311         lib/rapi/client_utils.py \
312         lib/rapi/connector.py \
313         lib/rapi/rlib2.py \
314         lib/rapi/testutils.py
315
316 http_PYTHON = \
317         lib/http/__init__.py \
318         lib/http/auth.py \
319         lib/http/client.py \
320         lib/http/server.py
321
322 confd_PYTHON = \
323         lib/confd/__init__.py \
324         lib/confd/client.py
325
326 masterd_PYTHON = \
327         lib/masterd/__init__.py \
328         lib/masterd/iallocator.py \
329         lib/masterd/instance.py
330
331 impexpd_PYTHON = \
332         lib/impexpd/__init__.py
333
334 watcher_PYTHON = \
335         lib/watcher/__init__.py \
336         lib/watcher/nodemaint.py \
337         lib/watcher/state.py
338
339 server_PYTHON = \
340         lib/server/__init__.py \
341         lib/server/masterd.py \
342         lib/server/noded.py \
343         lib/server/rapi.py
344
345 pytools_PYTHON = \
346         lib/tools/__init__.py \
347         lib/tools/burnin.py \
348         lib/tools/ensure_dirs.py \
349         lib/tools/node_cleanup.py \
350         lib/tools/node_daemon_setup.py \
351         lib/tools/prepare_node_join.py
352
353 utils_PYTHON = \
354         lib/utils/__init__.py \
355         lib/utils/algo.py \
356         lib/utils/filelock.py \
357         lib/utils/hash.py \
358         lib/utils/io.py \
359         lib/utils/log.py \
360         lib/utils/lvm.py \
361         lib/utils/mlock.py \
362         lib/utils/nodesetup.py \
363         lib/utils/process.py \
364         lib/utils/retry.py \
365         lib/utils/text.py \
366         lib/utils/wrapper.py \
367         lib/utils/x509.py
368
369 docinput = \
370         doc/conf.py \
371         doc/css/style.css \
372         doc/admin.rst \
373         doc/cluster-merge.rst \
374         doc/design-2.0.rst \
375         doc/design-2.1.rst \
376         doc/design-2.2.rst \
377         doc/design-2.3.rst \
378         doc/design-2.4.rst \
379         doc/design-2.5.rst \
380         doc/design-2.6.rst \
381         doc/design-2.7.rst \
382         doc/design-autorepair.rst \
383         doc/design-bulk-create.rst \
384         doc/design-chained-jobs.rst \
385         doc/design-cpu-pinning.rst \
386         doc/design-draft.rst \
387         doc/design-htools-2.3.rst \
388         doc/design-http-server.rst \
389         doc/design-impexp2.rst \
390         doc/design-lu-generated-jobs.rst \
391         doc/design-linuxha.rst \
392         doc/design-multi-reloc.rst \
393         doc/design-network.rst \
394         doc/design-node-add.rst \
395         doc/design-oob.rst \
396         doc/design-ovf-support.rst \
397         doc/design-opportunistic-locking.rst \
398         doc/design-partitioned.rst \
399         doc/design-query-splitting.rst \
400         doc/design-query2.rst \
401         doc/design-resource-model.rst \
402         doc/design-restricted-commands.rst \
403         doc/design-shared-storage.rst \
404         doc/design-monitoring-agent.rst \
405         doc/design-virtual-clusters.rst \
406         doc/design-x509-ca.rst \
407         doc/design-hroller.rst \
408         doc/design-storagespace.rst \
409         doc/devnotes.rst \
410         doc/glossary.rst \
411         doc/hooks.rst \
412         doc/iallocator.rst \
413         doc/index.rst \
414         doc/install-quick.rst \
415         doc/install.rst \
416         doc/locking.rst \
417         doc/manpages-disabled.rst \
418         doc/move-instance.rst \
419         doc/news.rst \
420         doc/ovfconverter.rst \
421         doc/rapi.rst \
422         doc/security.rst \
423         doc/upgrade.rst \
424         doc/virtual-cluster.rst \
425         doc/walkthrough.rst
426
427 # Generates file names such as "doc/man-gnt-instance.rst"
428 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
429
430 # Haskell programs to be installed in $PREFIX/bin
431 HS_BIN_PROGS=src/htools
432
433 # Haskell programs to be installed in the MYEXECLIB dir
434 HS_MYEXECLIB_PROGS=src/mon-collector
435
436 # Haskell programs to compiled but not installed automatically
437 # Usually they have their own specific installation rules
438 HS_COMPILE_PROGS= \
439         src/hconfd \
440         src/rpc-test
441
442 # All Haskell non-test programs to be compiled but not automatically installed
443 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
444
445 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
446 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
447
448 HS_ALL_PROGS = \
449         $(HS_PROGS) \
450         test/hs/hpc-htools \
451         test/hs/hpc-mon-collector \
452         test/hs/htest \
453         $(HS_COMPILE_PROGS)
454
455 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
456 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
457
458 HFLAGS = \
459         -O -Wall -Werror -isrc \
460         -fwarn-monomorphism-restriction \
461         -fwarn-tabs \
462         $(GHC_BYVERSION_FLAGS)
463
464 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
465 HEXTRA =
466 # internal extra flags (used for test/hs/htest mainly)
467 HEXTRA_INT =
468 # exclude options for coverage reports
469 HPCEXCL = --exclude Main \
470         --exclude Ganeti.Constants \
471         --exclude Ganeti.HTools.QC \
472         --exclude Ganeti.THH \
473         --exclude Ganeti.Version \
474         --exclude Test.Ganeti.Attoparsec \
475         --exclude Test.Ganeti.TestCommon \
476         --exclude Test.Ganeti.TestHTools \
477         --exclude Test.Ganeti.TestHelper \
478         --exclude Test.Ganeti.TestImports \
479         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
480
481 HS_LIB_SRCS = \
482         src/Ganeti/Block/Drbd/Types.hs \
483         src/Ganeti/Block/Drbd/Parser.hs \
484         src/Ganeti/BasicTypes.hs \
485         src/Ganeti/Common.hs \
486         src/Ganeti/Compat.hs \
487         src/Ganeti/Confd/Client.hs \
488         src/Ganeti/Confd/Server.hs \
489         src/Ganeti/Confd/Types.hs \
490         src/Ganeti/Confd/Utils.hs \
491         src/Ganeti/Config.hs \
492         src/Ganeti/Curl/Multi.hs \
493         src/Ganeti/Daemon.hs \
494         src/Ganeti/DataCollectors/CLI.hs \
495         src/Ganeti/DataCollectors/Drbd.hs \
496         src/Ganeti/DataCollectors/Program.hs \
497         src/Ganeti/DataCollectors/Types.hs \
498         src/Ganeti/Errors.hs \
499         src/Ganeti/HTools/Backend/IAlloc.hs \
500         src/Ganeti/HTools/Backend/Luxi.hs \
501         src/Ganeti/HTools/Backend/Rapi.hs \
502         src/Ganeti/HTools/Backend/Simu.hs \
503         src/Ganeti/HTools/Backend/Text.hs \
504         src/Ganeti/HTools/CLI.hs \
505         src/Ganeti/HTools/Cluster.hs \
506         src/Ganeti/HTools/Container.hs \
507         src/Ganeti/HTools/ExtLoader.hs \
508         src/Ganeti/HTools/Graph.hs \
509         src/Ganeti/HTools/Group.hs \
510         src/Ganeti/HTools/Instance.hs \
511         src/Ganeti/HTools/Loader.hs \
512         src/Ganeti/HTools/Node.hs \
513         src/Ganeti/HTools/PeerMap.hs \
514         src/Ganeti/HTools/Program/Hail.hs \
515         src/Ganeti/HTools/Program/Harep.hs \
516         src/Ganeti/HTools/Program/Hbal.hs \
517         src/Ganeti/HTools/Program/Hcheck.hs \
518         src/Ganeti/HTools/Program/Hinfo.hs \
519         src/Ganeti/HTools/Program/Hscan.hs \
520         src/Ganeti/HTools/Program/Hspace.hs \
521         src/Ganeti/HTools/Program/Hroller.hs \
522         src/Ganeti/HTools/Program/Main.hs \
523         src/Ganeti/HTools/Types.hs \
524         src/Ganeti/Hypervisor/Xen/XmParser.hs \
525         src/Ganeti/Hypervisor/Xen/Types.hs \
526         src/Ganeti/Hash.hs \
527         src/Ganeti/JQueue.hs \
528         src/Ganeti/JSON.hs \
529         src/Ganeti/Jobs.hs \
530         src/Ganeti/Logging.hs \
531         src/Ganeti/Luxi.hs \
532         src/Ganeti/Network.hs \
533         src/Ganeti/Objects.hs \
534         src/Ganeti/OpCodes.hs \
535         src/Ganeti/OpParams.hs \
536         src/Ganeti/Path.hs \
537         src/Ganeti/Query/Common.hs \
538         src/Ganeti/Query/Export.hs \
539         src/Ganeti/Query/Filter.hs \
540         src/Ganeti/Query/Group.hs \
541         src/Ganeti/Query/Job.hs \
542         src/Ganeti/Query/Language.hs \
543         src/Ganeti/Query/Network.hs \
544         src/Ganeti/Query/Node.hs \
545         src/Ganeti/Query/Query.hs \
546         src/Ganeti/Query/Server.hs \
547         src/Ganeti/Query/Types.hs \
548         src/Ganeti/Rpc.hs \
549         src/Ganeti/Runtime.hs \
550         src/Ganeti/Ssconf.hs \
551         src/Ganeti/THH.hs \
552         src/Ganeti/Types.hs \
553         src/Ganeti/Utils.hs
554
555 HS_TEST_SRCS = \
556         test/hs/Test/Ganeti/Attoparsec.hs \
557         test/hs/Test/Ganeti/BasicTypes.hs \
558         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
559         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
560         test/hs/Test/Ganeti/Common.hs \
561         test/hs/Test/Ganeti/Confd/Types.hs \
562         test/hs/Test/Ganeti/Confd/Utils.hs \
563         test/hs/Test/Ganeti/Daemon.hs \
564         test/hs/Test/Ganeti/Errors.hs \
565         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
566         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
567         test/hs/Test/Ganeti/HTools/CLI.hs \
568         test/hs/Test/Ganeti/HTools/Cluster.hs \
569         test/hs/Test/Ganeti/HTools/Container.hs \
570         test/hs/Test/Ganeti/HTools/Graph.hs \
571         test/hs/Test/Ganeti/HTools/Instance.hs \
572         test/hs/Test/Ganeti/HTools/Loader.hs \
573         test/hs/Test/Ganeti/HTools/Node.hs \
574         test/hs/Test/Ganeti/HTools/PeerMap.hs \
575         test/hs/Test/Ganeti/HTools/Types.hs \
576         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
577         test/hs/Test/Ganeti/JSON.hs \
578         test/hs/Test/Ganeti/Jobs.hs \
579         test/hs/Test/Ganeti/JQueue.hs \
580         test/hs/Test/Ganeti/Luxi.hs \
581         test/hs/Test/Ganeti/Network.hs \
582         test/hs/Test/Ganeti/Objects.hs \
583         test/hs/Test/Ganeti/OpCodes.hs \
584         test/hs/Test/Ganeti/Query/Filter.hs \
585         test/hs/Test/Ganeti/Query/Language.hs \
586         test/hs/Test/Ganeti/Query/Network.hs \
587         test/hs/Test/Ganeti/Query/Query.hs \
588         test/hs/Test/Ganeti/Rpc.hs \
589         test/hs/Test/Ganeti/Runtime.hs \
590         test/hs/Test/Ganeti/Ssconf.hs \
591         test/hs/Test/Ganeti/THH.hs \
592         test/hs/Test/Ganeti/TestCommon.hs \
593         test/hs/Test/Ganeti/TestHTools.hs \
594         test/hs/Test/Ganeti/TestHelper.hs \
595         test/hs/Test/Ganeti/Types.hs \
596         test/hs/Test/Ganeti/Utils.hs
597
598 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
599
600 HS_BUILT_SRCS = \
601         test/hs/Test/Ganeti/TestImports.hs \
602         src/Ganeti/Constants.hs \
603         src/Ganeti/Curl/Internal.hs \
604         src/Ganeti/Version.hs
605 HS_BUILT_SRCS_IN = \
606         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
607         src/Ganeti/Curl/Internal.hsc
608
609 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
610
611 $(RUN_IN_TEMPDIR): | stamp-directories
612
613 doc/html/index.html: ENABLE_MANPAGES =
614 doc/man-html/index.html: ENABLE_MANPAGES = 1
615 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
616
617 # Note: we use here an order-only prerequisite, as the contents of
618 # _autoconf.py are not actually influencing the html build output: it
619 # has to exist in order for the sphinx module to be loaded
620 # successfully, but we certainly don't want the docs to be rebuilt if
621 # it changes
622 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
623         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
624         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
625         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
626         | $(BUILT_PYTHON_SOURCES)
627         @test -n "$(SPHINX)" || \
628             { echo 'sphinx-build' not found during configure; exit 1; }
629 if !MANPAGES_IN_DOC
630         if test -n '$(ENABLE_MANPAGES)'; then \
631           echo 'Man pages in documentation were disabled at configure time' >&2; \
632           exit 1; \
633         fi
634 endif
635 ## Sphinx provides little control over what content should be included. Some
636 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
637 ## build two different versions of the documentation--once without man pages and
638 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
639 ## us with this, but requires running in a temporary directory. It moves the
640 ## correct files into place depending on environment variables.
641         dir=$(dir $@) && \
642         @mkdir_p@ $$dir && \
643         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
644         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
645             -d . \
646             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
647             -D release="$(PACKAGE_VERSION)" \
648             -D graphviz_dot="$(DOT)" \
649             -D enable_manpages="$(ENABLE_MANPAGES)" \
650             doc $(CURDIR)/$$dir && \
651         rm -f $$dir/.buildinfo $$dir/objects.inv
652         touch $@
653
654 doc/html: doc/html/index.html
655
656 doc/man-html: doc/man-html/index.html
657
658 doc/install-quick.rst: INSTALL
659 doc/news.rst: NEWS
660 doc/upgrade.rst: UPGRADE
661
662 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
663         set -e; \
664         { echo '.. This file is automatically updated at build time from $<.'; \
665           echo '.. Do not edit.'; \
666           echo; \
667           cat $<; \
668         } > $@
669
670 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
671         { echo '.. This file is automatically generated, do not edit!'; \
672           echo ''; \
673           echo 'Man pages'; \
674           echo '========='; \
675           echo; \
676           echo '.. toctree::'; \
677           echo '   :maxdepth: 1'; \
678           echo; \
679           for i in $(notdir $(mandocrst)); do \
680             echo "   $$i"; \
681           done | LC_ALL=C sort; \
682         } > $@
683
684 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
685 if MANPAGES_IN_DOC
686         { echo '.. This file is automatically updated at build time from $<.'; \
687           echo '.. Do not edit.'; \
688           echo; \
689           echo "$*"; \
690           echo '=========================================='; \
691           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
692         } > $@
693 else
694         echo 'Man pages in documentation were disabled at configure time' >&2; \
695         exit 1;
696 endif
697
698 # Things to build but not to install (add it to EXTRA_DIST if it should be
699 # distributed)
700 noinst_DATA = \
701         doc/html \
702         $(BUILT_EXAMPLES) \
703         doc/examples/bash_completion \
704         doc/examples/bash_completion-debug \
705         $(manhtml)
706
707 if MANPAGES_IN_DOC
708 noinst_DATA += doc/man-html
709 endif
710
711 gnt_scripts = \
712         scripts/gnt-backup \
713         scripts/gnt-cluster \
714         scripts/gnt-debug \
715         scripts/gnt-group \
716         scripts/gnt-instance \
717         scripts/gnt-job \
718         scripts/gnt-network \
719         scripts/gnt-node \
720         scripts/gnt-os \
721         scripts/gnt-storage
722
723 PYTHON_BOOTSTRAP_SBIN = \
724         daemons/ganeti-masterd \
725         daemons/ganeti-noded \
726         daemons/ganeti-rapi \
727         daemons/ganeti-watcher \
728         $(gnt_scripts)
729
730 PYTHON_BOOTSTRAP = \
731         $(PYTHON_BOOTSTRAP_SBIN) \
732         tools/burnin \
733         tools/ensure-dirs \
734         tools/node-cleanup \
735         tools/node-daemon-setup \
736         tools/prepare-node-join
737
738 qa_scripts = \
739         qa/__init__.py \
740         qa/ganeti-qa.py \
741         qa/qa_cluster.py \
742         qa/qa_config.py \
743         qa/qa_daemon.py \
744         qa/qa_env.py \
745         qa/qa_error.py \
746         qa/qa_group.py \
747         qa/qa_instance.py \
748         qa/qa_job.py \
749         qa/qa_node.py \
750         qa/qa_os.py \
751         qa/qa_rapi.py \
752         qa/qa_tags.py \
753         qa/qa_utils.py
754
755 bin_SCRIPTS =
756 if WANT_HTOOLS
757 bin_SCRIPTS += $(HS_BIN_PROGS)
758 install-exec-hook:
759         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
760 # FIXME: this is a hardcoded logic, instead of auto-resolving
761         $(LN_S) -f ../../../bin/htools \
762           $(DESTDIR)$(iallocatorsdir)/hail
763         for role in $(HS_BIN_ROLES); do \
764           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
765         done
766 endif
767
768 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
769         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
770           echo "Error: cannot run unittests without the development" \
771                " libraries (see devnotes.rst)" 1>&2; \
772           exit 1; \
773         fi
774         @rm -f $(notdir $@).tix
775         $(GHC) --make \
776           $(HFLAGS) \
777           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
778           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
779           $(HEXTRA) $(HEXTRA_INT) $@
780         @touch "$@"
781
782 # for the test/hs/htest binary, we need to enable profiling/coverage
783 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
784
785 # we compile the hpc-htools binary with the program coverage
786 test/hs/hpc-htools: HEXTRA_INT=-fhpc
787
788 # we compile the hpc-mon-collector binary with the program coverage
789 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
790
791 # test dependency
792 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
793
794 # rules for building profiling-enabled versions of the haskell
795 # programs: hs-prof does the full two-step build, whereas
796 # hs-prof-quick does only the final rebuild (hs-prof must have been
797 # run before)
798 .PHONY: hs-prof hs-prof-quick
799 hs-prof:
800         @if [ -z "$(TARGET)" ]; then \
801           echo "You need to define TARGET when running this rule" 1>&2; \
802           exit 1; \
803         fi
804         $(MAKE) $(AM_MAKEFLAGS) clean
805         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
806         rm -f $(HS_ALL_PROGS)
807         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
808
809 hs-prof-quick:
810         @if [ -z "$(TARGET)" ]; then \
811           echo "You need to define TARGET when running this rule" 1>&2; \
812           exit 1; \
813         fi
814         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
815
816 dist_sbin_SCRIPTS = \
817         tools/ganeti-listrunner
818
819 nodist_sbin_SCRIPTS = \
820         $(PYTHON_BOOTSTRAP_SBIN) \
821         daemons/ganeti-cleaner
822
823 if ENABLE_CONFD
824 src/ganeti-confd: src/hconfd
825         cp -f $< $@
826
827 nodist_sbin_SCRIPTS += src/ganeti-confd
828 endif
829
830 python_scripts = \
831         tools/cfgshell \
832         tools/cfgupgrade \
833         tools/cfgupgrade12 \
834         tools/cluster-merge \
835         tools/confd-client \
836         tools/fmtjson \
837         tools/lvmstrap \
838         tools/move-instance \
839         tools/ovfconverter \
840         tools/sanitize-config
841
842 dist_tools_SCRIPTS = \
843         $(python_scripts) \
844         tools/kvm-console-wrapper \
845         tools/master-ip-setup \
846         tools/xen-console-wrapper
847
848 nodist_tools_python_scripts = \
849         tools/node-cleanup
850
851 nodist_tools_SCRIPTS = \
852         $(nodist_tools_python_scripts) \
853         tools/vcluster-setup
854
855 pkglib_python_scripts = \
856         daemons/import-export \
857         tools/check-cert-expired
858
859 nodist_pkglib_python_scripts = \
860         tools/burnin \
861         tools/ensure-dirs \
862         tools/node-daemon-setup \
863         tools/prepare-node-join
864
865 myexeclib_SCRIPTS = \
866         daemons/daemon-util \
867         tools/kvm-ifup \
868         $(pkglib_python_scripts) \
869         $(HS_MYEXECLIB_PROGS)
870
871 nodist_myexeclib_SCRIPTS = \
872         $(nodist_pkglib_python_scripts)
873
874 EXTRA_DIST = \
875         NEWS \
876         UPGRADE \
877         epydoc.conf.in \
878         pylintrc \
879         autotools/build-bash-completion \
880         autotools/build-rpc \
881         autotools/check-header \
882         autotools/check-imports \
883         autotools/check-man-dashes \
884         autotools/check-man-references \
885         autotools/check-man-warnings \
886         autotools/check-news \
887         autotools/check-python-code \
888         autotools/check-tar \
889         autotools/check-version \
890         autotools/convert-constants \
891         autotools/docpp \
892         autotools/gen-py-coverage \
893         autotools/sphinx-wrapper \
894         autotools/testrunner \
895         autotools/wrong-hardcoded-paths \
896         $(RUN_IN_TEMPDIR) \
897         daemons/daemon-util.in \
898         daemons/ganeti-cleaner.in \
899         $(pkglib_python_scripts) \
900         devel/upload \
901         devel/webserver \
902         tools/kvm-ifup.in \
903         tools/vcluster-setup.in \
904         $(docinput) \
905         doc/html \
906         $(BUILT_EXAMPLES:%=%.in) \
907         doc/examples/ganeti.default \
908         doc/examples/ganeti.default-debug \
909         doc/examples/hooks/ethers \
910         doc/examples/gnt-debug/README \
911         doc/examples/gnt-debug/delay0.json \
912         doc/examples/gnt-debug/delay50.json \
913         test/py/lockperf.py \
914         test/py/testutils.py \
915         test/py/mocks.py \
916         $(dist_TESTS) \
917         $(TEST_FILES) \
918         man/footer.rst \
919         $(manrst) \
920         $(maninput) \
921         qa/qa-sample.json \
922         $(qa_scripts) \
923         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
924         $(HS_PROG_SRCS) \
925         src/lint-hints.hs \
926         test/hs/cli-tests-defs.sh \
927         test/hs/offline-test.sh \
928         .ghci
929
930 man_MANS = \
931         man/ganeti-cleaner.8 \
932         man/ganeti-confd.8 \
933         man/ganeti-listrunner.8 \
934         man/ganeti-masterd.8 \
935         man/ganeti-noded.8 \
936         man/ganeti-os-interface.7 \
937         man/ganeti-extstorage-interface.7 \
938         man/ganeti-rapi.8 \
939         man/ganeti-watcher.8 \
940         man/ganeti.7 \
941         man/gnt-backup.8 \
942         man/gnt-cluster.8 \
943         man/gnt-debug.8 \
944         man/gnt-group.8 \
945         man/gnt-network.8 \
946         man/gnt-instance.8 \
947         man/gnt-job.8 \
948         man/gnt-node.8 \
949         man/gnt-os.8 \
950         man/gnt-storage.8 \
951         man/hail.1 \
952         man/hbal.1 \
953         man/hcheck.1 \
954         man/hinfo.1 \
955         man/hscan.1 \
956         man/hspace.1 \
957         man/hroller.1 \
958         man/htools.1 \
959         man/mon-collector.7
960
961 # Remove extensions from all filenames in man_MANS
962 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
963
964 manrst = $(patsubst %,%.rst,$(mannoext))
965 manhtml = $(patsubst %.rst,%.html,$(manrst))
966 mangen = $(patsubst %.rst,%.gen,$(manrst))
967 maninput = \
968         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
969         $(patsubst %.html,%.html.in,$(manhtml)) \
970         $(mangen)
971
972 TEST_FILES = \
973         test/data/htools/clean-nonzero-score.data \
974         test/data/htools/common-suffix.data \
975         test/data/htools/empty-cluster.data \
976         test/data/htools/hail-alloc-drbd.json \
977         test/data/htools/hail-change-group.json \
978         test/data/htools/hail-invalid-reloc.json \
979         test/data/htools/hail-node-evac.json \
980         test/data/htools/hail-reloc-drbd.json \
981         test/data/htools/hbal-excl-tags.data \
982         test/data/htools/hbal-split-insts.data \
983         test/data/htools/invalid-node.data \
984         test/data/htools/missing-resources.data \
985         test/data/htools/n1-failure.data \
986         test/data/htools/rapi/groups.json \
987         test/data/htools/rapi/info.json \
988         test/data/htools/rapi/instances.json \
989         test/data/htools/rapi/nodes.json \
990         test/hs/shelltests/htools-balancing.test \
991         test/hs/shelltests/htools-basic.test \
992         test/hs/shelltests/htools-dynutil.test \
993         test/hs/shelltests/htools-excl.test \
994         test/hs/shelltests/htools-hail.test \
995         test/hs/shelltests/htools-hspace.test \
996         test/hs/shelltests/htools-invalid.test \
997         test/hs/shelltests/htools-multi-group.test \
998         test/hs/shelltests/htools-no-backend.test \
999         test/hs/shelltests/htools-rapi.test \
1000         test/hs/shelltests/htools-single-group.test \
1001         test/hs/shelltests/htools-text-backend.test \
1002         test/hs/shelltests/htools-mon-collector.test \
1003         test/data/bdev-drbd-8.0.txt \
1004         test/data/bdev-drbd-8.3.txt \
1005         test/data/bdev-drbd-disk.txt \
1006         test/data/bdev-drbd-net-ip4.txt \
1007         test/data/bdev-drbd-net-ip6.txt \
1008         test/data/bdev-rbd/json_output_empty.txt \
1009         test/data/bdev-rbd/json_output_extra_matches.txt \
1010         test/data/bdev-rbd/json_output_no_matches.txt \
1011         test/data/bdev-rbd/json_output_ok.txt \
1012         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1013         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1014         test/data/bdev-rbd/plain_output_new_ok.txt \
1015         test/data/bdev-rbd/plain_output_old_empty.txt \
1016         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1017         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1018         test/data/bdev-rbd/plain_output_old_ok.txt \
1019         test/data/bdev-rbd/output_invalid.txt \
1020         test/data/cert1.pem \
1021         test/data/cert2.pem \
1022         test/data/instance-minor-pairing.txt \
1023         test/data/ip-addr-show-dummy0.txt \
1024         test/data/ip-addr-show-lo-ipv4.txt \
1025         test/data/ip-addr-show-lo-ipv6.txt \
1026         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1027         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1028         test/data/ip-addr-show-lo-oneline.txt \
1029         test/data/ip-addr-show-lo.txt \
1030         test/data/kvm_0.12.5_help.txt \
1031         test/data/kvm_0.15.90_help.txt \
1032         test/data/kvm_0.9.1_help.txt \
1033         test/data/kvm_0.9.1_help_boot_test.txt \
1034         test/data/kvm_1.0_help.txt \
1035         test/data/kvm_1.1.2_help.txt \
1036         test/data/ovfdata/compr_disk.vmdk.gz \
1037         test/data/ovfdata/config.ini \
1038         test/data/ovfdata/corrupted_resources.ovf \
1039         test/data/ovfdata/empty.ini \
1040         test/data/ovfdata/empty.ovf \
1041         test/data/ovfdata/ganeti.mf \
1042         test/data/ovfdata/ganeti.ovf \
1043         test/data/ovfdata/gzip_disk.ovf \
1044         test/data/ovfdata/new_disk.vmdk \
1045         test/data/ovfdata/no_disk.ini \
1046         test/data/ovfdata/no_disk_in_ref.ovf \
1047         test/data/ovfdata/no_os.ini \
1048         test/data/ovfdata/no_ovf.ova \
1049         test/data/ovfdata/other/rawdisk.raw \
1050         test/data/ovfdata/ova.ova \
1051         test/data/ovfdata/rawdisk.raw \
1052         test/data/ovfdata/second_disk.vmdk \
1053         test/data/ovfdata/unsafe_path.ini \
1054         test/data/ovfdata/virtualbox.ovf \
1055         test/data/ovfdata/wrong_config.ini \
1056         test/data/ovfdata/wrong_extension.ovd \
1057         test/data/ovfdata/wrong_manifest.mf \
1058         test/data/ovfdata/wrong_manifest.ovf \
1059         test/data/ovfdata/wrong_ova.ova \
1060         test/data/ovfdata/wrong_xml.ovf \
1061         test/data/proc_drbd8.txt \
1062         test/data/proc_drbd80-emptyline.txt \
1063         test/data/proc_drbd83.txt \
1064         test/data/proc_drbd83_sync.txt \
1065         test/data/proc_drbd83_sync_want.txt \
1066         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1067         test/data/qa-minimal-nodes-instances-only.json \
1068         test/data/sys_drbd_usermode_helper.txt \
1069         test/data/vgreduce-removemissing-2.02.02.txt \
1070         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1071         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1072         test/data/vgs-missing-pvs-2.02.02.txt \
1073         test/data/vgs-missing-pvs-2.02.66.txt \
1074         test/data/xen-xm-info-4.0.1.txt \
1075         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1076         test/data/xen-xm-list-4.0.1-four-instances.txt \
1077         test/data/xen-xm-list-long-4.0.1.txt \
1078         test/data/xen-xm-uptime-4.0.1.txt \
1079         test/py/ganeti-cli.test \
1080         test/py/gnt-cli.test \
1081         test/py/import-export_unittest-helper
1082
1083 python_tests = \
1084         doc/examples/rapi_testutils.py \
1085         test/py/cfgupgrade_unittest.py \
1086         test/py/docs_unittest.py \
1087         test/py/ganeti.asyncnotifier_unittest.py \
1088         test/py/ganeti.backend_unittest-runasroot.py \
1089         test/py/ganeti.backend_unittest.py \
1090         test/py/ganeti.bdev_unittest.py \
1091         test/py/ganeti.cli_unittest.py \
1092         test/py/ganeti.client.gnt_cluster_unittest.py \
1093         test/py/ganeti.client.gnt_instance_unittest.py \
1094         test/py/ganeti.client.gnt_job_unittest.py \
1095         test/py/ganeti.cmdlib_unittest.py \
1096         test/py/ganeti.compat_unittest.py \
1097         test/py/ganeti.confd.client_unittest.py \
1098         test/py/ganeti.config_unittest.py \
1099         test/py/ganeti.constants_unittest.py \
1100         test/py/ganeti.daemon_unittest.py \
1101         test/py/ganeti.errors_unittest.py \
1102         test/py/ganeti.hooks_unittest.py \
1103         test/py/ganeti.ht_unittest.py \
1104         test/py/ganeti.http_unittest.py \
1105         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1106         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1107         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1108         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1109         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1110         test/py/ganeti.hypervisor_unittest.py \
1111         test/py/ganeti.impexpd_unittest.py \
1112         test/py/ganeti.jqueue_unittest.py \
1113         test/py/ganeti.jstore_unittest.py \
1114         test/py/ganeti.locking_unittest.py \
1115         test/py/ganeti.luxi_unittest.py \
1116         test/py/ganeti.masterd.iallocator_unittest.py \
1117         test/py/ganeti.masterd.instance_unittest.py \
1118         test/py/ganeti.mcpu_unittest.py \
1119         test/py/ganeti.netutils_unittest.py \
1120         test/py/ganeti.objects_unittest.py \
1121         test/py/ganeti.opcodes_unittest.py \
1122         test/py/ganeti.outils_unittest.py \
1123         test/py/ganeti.ovf_unittest.py \
1124         test/py/ganeti.qlang_unittest.py \
1125         test/py/ganeti.query_unittest.py \
1126         test/py/ganeti.rapi.baserlib_unittest.py \
1127         test/py/ganeti.rapi.client_unittest.py \
1128         test/py/ganeti.rapi.resources_unittest.py \
1129         test/py/ganeti.rapi.rlib2_unittest.py \
1130         test/py/ganeti.rapi.testutils_unittest.py \
1131         test/py/ganeti.rpc_unittest.py \
1132         test/py/ganeti.runtime_unittest.py \
1133         test/py/ganeti.serializer_unittest.py \
1134         test/py/ganeti.server.rapi_unittest.py \
1135         test/py/ganeti.ssconf_unittest.py \
1136         test/py/ganeti.ssh_unittest.py \
1137         test/py/ganeti.storage_unittest.py \
1138         test/py/ganeti.tools.burnin_unittest.py \
1139         test/py/ganeti.tools.ensure_dirs_unittest.py \
1140         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1141         test/py/ganeti.tools.prepare_node_join_unittest.py \
1142         test/py/ganeti.uidpool_unittest.py \
1143         test/py/ganeti.utils.algo_unittest.py \
1144         test/py/ganeti.utils.filelock_unittest.py \
1145         test/py/ganeti.utils.hash_unittest.py \
1146         test/py/ganeti.utils.io_unittest-runasroot.py \
1147         test/py/ganeti.utils.io_unittest.py \
1148         test/py/ganeti.utils.log_unittest.py \
1149         test/py/ganeti.utils.lvm_unittest.py \
1150         test/py/ganeti.utils.mlock_unittest.py \
1151         test/py/ganeti.utils.nodesetup_unittest.py \
1152         test/py/ganeti.utils.process_unittest.py \
1153         test/py/ganeti.utils.retry_unittest.py \
1154         test/py/ganeti.utils.text_unittest.py \
1155         test/py/ganeti.utils.wrapper_unittest.py \
1156         test/py/ganeti.utils.x509_unittest.py \
1157         test/py/ganeti.utils_unittest.py \
1158         test/py/ganeti.vcluster_unittest.py \
1159         test/py/ganeti.workerpool_unittest.py \
1160         test/py/pycurl_reset_unittest.py \
1161         test/py/qa.qa_config_unittest.py \
1162         test/py/tempfile_fork_unittest.py
1163
1164 haskell_tests = test/hs/htest
1165
1166 dist_TESTS = \
1167         test/py/check-cert-expired_unittest.bash \
1168         test/py/daemon-util_unittest.bash \
1169         test/py/ganeti-cleaner_unittest.bash \
1170         test/py/import-export_unittest.bash \
1171         test/py/cli-test.bash \
1172         test/py/bash_completion.bash \
1173         $(python_tests)
1174
1175 nodist_TESTS =
1176 check_SCRIPTS =
1177
1178 if WANT_HSTESTS
1179 nodist_TESTS += $(haskell_tests)
1180 dist_TESTS += test/hs/offline-test.sh
1181 check_SCRIPTS += \
1182         test/hs/hpc-htools \
1183         test/hs/hpc-mon-collector \
1184         $(HS_BUILT_TEST_HELPERS)
1185 endif
1186
1187 TESTS = $(dist_TESTS) $(nodist_TESTS)
1188
1189 # Environment for all tests
1190 PLAIN_TESTS_ENVIRONMENT = \
1191         PYTHONPATH=. \
1192         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1193         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1194         $(RUN_IN_TEMPDIR)
1195
1196 # Environment for tests run by automake
1197 TESTS_ENVIRONMENT = \
1198         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1199
1200 all_python_code = \
1201         $(dist_sbin_SCRIPTS) \
1202         $(python_scripts) \
1203         $(pkglib_python_scripts) \
1204         $(nodist_pkglib_python_scripts) \
1205         $(nodist_tools_python_scripts) \
1206         $(python_tests) \
1207         $(pkgpython_PYTHON) \
1208         $(client_PYTHON) \
1209         $(hypervisor_PYTHON) \
1210         $(rapi_PYTHON) \
1211         $(server_PYTHON) \
1212         $(pytools_PYTHON) \
1213         $(http_PYTHON) \
1214         $(confd_PYTHON) \
1215         $(masterd_PYTHON) \
1216         $(impexpd_PYTHON) \
1217         $(utils_PYTHON) \
1218         $(watcher_PYTHON) \
1219         $(noinst_PYTHON) \
1220         $(qa_scripts)
1221
1222 srclink_files = \
1223         man/footer.rst \
1224         test/py/check-cert-expired_unittest.bash \
1225         test/py/daemon-util_unittest.bash \
1226         test/py/ganeti-cleaner_unittest.bash \
1227         test/py/import-export_unittest.bash \
1228         test/py/cli-test.bash \
1229         test/py/bash_completion.bash \
1230         test/hs/offline-test.sh \
1231         test/hs/cli-tests-defs.sh \
1232         $(all_python_code) \
1233         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1234         $(docinput)
1235
1236 check_python_code = \
1237         $(BUILD_BASH_COMPLETION) \
1238         $(CHECK_IMPORTS) \
1239         $(CHECK_HEADER) \
1240         $(DOCPP) \
1241         $(all_python_code)
1242
1243 lint_python_code = \
1244         ganeti \
1245         ganeti/http/server.py \
1246         $(dist_sbin_SCRIPTS) \
1247         $(python_scripts) \
1248         $(pkglib_python_scripts) \
1249         $(BUILD_BASH_COMPLETION) \
1250         $(CHECK_IMPORTS) \
1251         $(CHECK_HEADER) \
1252         $(DOCPP) \
1253         $(PYTHON_BOOTSTRAP)
1254
1255 standalone_python_modules = \
1256         lib/rapi/client.py \
1257         tools/ganeti-listrunner
1258
1259 pep8_python_code = \
1260         ganeti \
1261         ganeti/http/server.py \
1262         $(dist_sbin_SCRIPTS) \
1263         $(python_scripts) \
1264         $(pkglib_python_scripts) \
1265         $(BUILD_BASH_COMPLETION) \
1266         $(CHECK_HEADER) \
1267         $(DOCPP) \
1268         $(PYTHON_BOOTSTRAP) \
1269         qa
1270
1271 test/py/daemon-util_unittest.bash: daemons/daemon-util
1272
1273 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1274
1275 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1276
1277 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1278         sed -f $(REPLACE_VARS_SED) < $< > $@
1279         chmod +x $@
1280
1281 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1282         sed -f $(REPLACE_VARS_SED) < $< > $@
1283         chmod +x $@
1284
1285 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1286         sed -f $(REPLACE_VARS_SED) < $< > $@
1287         chmod +x $@
1288
1289 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1290         sed -f $(REPLACE_VARS_SED) < $< > $@
1291
1292 doc/examples/bash_completion: BC_ARGS = --compact
1293 doc/examples/bash_completion-debug: BC_ARGS =
1294
1295 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1296         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1297         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1298         daemons/ganeti-cleaner \
1299         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1300         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1301           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1302
1303 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1304         lib/build/shell_example_lexer.py \
1305         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1306         @echo "Checking $< for hardcoded paths..."
1307         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1308           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1309           exit 1; \
1310         fi
1311         set -e ; \
1312         trap 'echo auto-removing $@; rm $@' EXIT; \
1313         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1314         $(CHECK_MAN_REFERENCES) $@; \
1315         trap - EXIT
1316
1317 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1318         @test -n "$(PANDOC)" || \
1319           { echo 'pandoc' not found during configure; exit 1; }
1320         set -o pipefail -e; \
1321         trap 'echo auto-removing $@; rm $@' EXIT; \
1322         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1323           sed -e 's/\\@/@/g' > $@; \
1324         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1325         $(CHECK_MAN_DASHES) $@; \
1326         trap - EXIT
1327
1328 man/%.html.in: man/%.gen man/footer.rst
1329         @test -n "$(PANDOC)" || \
1330           { echo 'pandoc' not found during configure; exit 1; }
1331         set -o pipefail ; \
1332         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1333           sed -e 's/\\@/@/g' > $@
1334
1335 man/%: man/%.in  $(REPLACE_VARS_SED)
1336         sed -f $(REPLACE_VARS_SED) < $< > $@
1337
1338 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1339         sed -f $(REPLACE_VARS_SED) < $< > $@
1340
1341 vcs-version:
1342         if test -d .git; then \
1343           git describe > $@; \
1344         elif test ! -f $@ ; then \
1345           echo "Cannot auto-generate $@ file"; exit 1; \
1346         fi
1347
1348 .PHONY: clean-vcs-version
1349 clean-vcs-version:
1350         rm -f vcs-version
1351
1352 .PHONY: regen-vcs-version
1353 regen-vcs-version:
1354         @set -e; \
1355         cd $(srcdir); \
1356         if test -d .git; then \
1357           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1358           git describe > $$T; \
1359           if ! cmp --quiet $$T vcs-version; then \
1360             mv $$T vcs-version; \
1361           fi; \
1362         fi
1363
1364 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1365         vcs-version $(built_base_sources)
1366         set -e; \
1367         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1368         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1369
1370 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1371         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1372         lib/jstore.py $(RUN_IN_TEMPDIR) \
1373         $(CONVERT_CONSTANTS) $(built_base_sources) \
1374         | lib/_vcsversion.py
1375         set -e; \
1376         { cat $< ; \
1377           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1378         } > $@
1379
1380 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1381         hsc2hs -o $@ $<
1382
1383 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1384         $(built_base_sources)
1385         set -e; \
1386         { cat $< ; \
1387           echo ; \
1388           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1389             echo "import $$name ()" ; \
1390           done ; \
1391         } > $@
1392
1393 lib/_autoconf.py: Makefile | stamp-directories
1394         set -e; \
1395         { echo '# This file is automatically generated, do not edit!'; \
1396           echo '#'; \
1397           echo ''; \
1398           echo '"""Build-time configuration for Ganeti.'; \
1399           echo '';\
1400           echo 'This file is autogenerated by the build process.'; \
1401           echo 'For any changes you need to re-run ./configure (and'; \
1402           echo 'not edit by hand).'; \
1403           echo ''; \
1404           echo '"""'; \
1405           echo ''; \
1406           echo '# pylint: disable=C0301,C0324'; \
1407           echo '# because this is autogenerated, we do not want'; \
1408           echo '# style warnings' ; \
1409           echo ''; \
1410           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1411           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1412           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1413           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1414           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1415           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1416           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1417           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1418           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1419           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1420           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1421           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1422           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1423           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1424           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1425           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1426           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1427           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1428           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1429           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1430           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1431           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1432           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1433           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1434           echo "KVM_PATH = '$(KVM_PATH)'"; \
1435           echo "IP_PATH = '$(IP_PATH)'"; \
1436           echo "SOCAT_PATH = '$(SOCAT)'"; \
1437           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1438           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1439           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1440           echo "TOOLSDIR = '$(toolsdir)'"; \
1441           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1442           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1443           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1444           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1445           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1446           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1447           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1448           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1449           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1450           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1451           echo "RAPI_USER = '$(RAPI_USER)'"; \
1452           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1453           echo "CONFD_USER = '$(CONFD_USER)'"; \
1454           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1455           echo "NODED_USER = '$(NODED_USER)'"; \
1456           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1457           echo "MOND_USER = '$(MOND_USER)'"; \
1458           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1459           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1460           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1461           echo "HTOOLS = True"; \
1462           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1463           echo "XEN_CMD = '$(XEN_CMD)'"; \
1464           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1465           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1466           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1467 ## Write dictionary with man page name as the key and the section number as the
1468 ## value
1469           echo "MAN_PAGES = {"; \
1470           for i in $(notdir $(man_MANS)); do \
1471             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1472           done; \
1473           echo "}"; \
1474         } > $@
1475
1476 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1477         set -e; \
1478         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1479         { echo '# This file is automatically generated, do not edit!'; \
1480           echo '#'; \
1481           echo ''; \
1482           echo '"""Build-time VCS version number for Ganeti.'; \
1483           echo '';\
1484           echo 'This file is autogenerated by the build process.'; \
1485           echo 'For any changes you need to re-run ./configure (and'; \
1486           echo 'not edit by hand).'; \
1487           echo ''; \
1488           echo '"""'; \
1489           echo ''; \
1490           echo '# pylint: disable=C0301,C0324'; \
1491           echo '# because this is autogenerated, we do not want'; \
1492           echo '# style warnings' ; \
1493           echo ''; \
1494           echo "VCS_VERSION = '$$VCSVER'"; \
1495         } > $@
1496
1497 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1498         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1499
1500 $(SHELL_ENV_INIT): Makefile stamp-directories
1501         set -e; \
1502         { echo '# Allow overriding for tests'; \
1503           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1504           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1505           echo; \
1506           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1507           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1508           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1509           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1510           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1511         } > $@
1512
1513 ## Writes sed script to replace placeholders with build-time values. The
1514 ## additional quotes after the first @ sign are necessary to stop configure
1515 ## from replacing those values as well.
1516 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1517         set -e; \
1518         { echo 's#@''PREFIX@#$(prefix)#g'; \
1519           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1520           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1521           echo 's#@''BINDIR@#$(bindir)#g'; \
1522           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1523           echo 's#@''LIBDIR@#$(libdir)#g'; \
1524           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1525           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1526           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1527           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1528           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1529           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1530           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1531           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1532           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1533           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1534           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1535           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1536           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1537           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1538           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1539           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1540           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1541           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1542           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1543           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1544           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1545           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1546           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1547           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1548           echo; \
1549           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1550           echo '  r $(SHELL_ENV_INIT)'; \
1551           echo '  d'; \
1552           echo '}'; \
1553         } > $@
1554
1555 # Using deferred evaluation
1556 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1557 daemons/ganeti-watcher: MODULE = ganeti.watcher
1558 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1559 tools/burnin: MODULE = ganeti.tools.burnin
1560 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1561 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1562 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1563 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1564 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1565
1566 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1567         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1568         set -e; \
1569         { echo '#!/usr/bin/python'; \
1570           echo '# This file is automatically generated, do not edit!'; \
1571           echo "# Edit $(MODULE) instead."; \
1572           echo; \
1573           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1574           echo; \
1575           echo '# pylint: disable=C0103'; \
1576           echo '# C0103: Invalid name'; \
1577           echo; \
1578           echo 'import sys'; \
1579           echo 'import $(MODULE) as main'; \
1580           echo; \
1581           echo '# Temporarily alias commands until bash completion'; \
1582           echo '# generator is changed'; \
1583           echo 'if hasattr(main, "commands"):'; \
1584           echo '  commands = main.commands # pylint: disable=E1101'; \
1585           echo 'if hasattr(main, "aliases"):'; \
1586           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1587           echo; \
1588           echo 'if __name__ == "__main__":'; \
1589           echo '  sys.exit(main.Main())'; \
1590         } > $@
1591         chmod u+x $@
1592
1593 $(HS_BUILT_TEST_HELPERS): Makefile
1594         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1595         set -e; \
1596         { echo '#!/bin/sh'; \
1597           echo '# This file is automatically generated, do not edit!'; \
1598           echo "# Edit Makefile.am instead."; \
1599           echo; \
1600           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1601         } > $@
1602         chmod u+x $@
1603
1604 stamp-directories: Makefile
1605         $(MAKE) $(AM_MAKEFLAGS) ganeti
1606         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1607         touch $@
1608
1609 # We need to create symlinks because "make distcheck" will not install Python
1610 # files when building.
1611 stamp-srclinks: Makefile | stamp-directories
1612         set -e; \
1613         for i in $(srclink_files); do \
1614           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1615             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1616           fi; \
1617         done
1618         touch $@
1619
1620 .PHONY: ganeti
1621 ganeti:
1622         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1623
1624 .PHONY: check-dirs
1625 check-dirs: $(GENERATED_FILES)
1626         @set -e; \
1627         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1628           error=; \
1629           while read dir; do \
1630             case "$$dir" in \
1631               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1632               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1633             esac; \
1634           done; \
1635           for dir in $(DIRS); do \
1636             if ! test -d "$$dir"; then \
1637               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1638               error=1; \
1639             fi \
1640           done; \
1641           test -z "$$error"; \
1642         }
1643
1644 .PHONY: check-local
1645 check-local: check-dirs $(GENERATED_FILES)
1646         $(CHECK_PYTHON_CODE) $(check_python_code)
1647         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1648         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1649         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1650         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1651         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1652         error= ; \
1653         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1654           echo "Incorrect version in README, expected $$expver" >&2; \
1655           error=1; \
1656         fi; \
1657         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1658             doc/security.rst; do \
1659           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1660             "Documents Ganeti version $$expver"; then \
1661             echo "Incorrect version in $$file, expected $$expver" >&2; \
1662             error=1; \
1663           fi; \
1664         done; \
1665         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1666           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1667           error=1; \
1668         fi; \
1669         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1670           ".. Last updated for Ganeti $$expver"; then \
1671           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1672           error=1; \
1673         fi; \
1674         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1675           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1676             echo "Longest line in $$file is longer than 80 characters" >&2; \
1677             error=1; \
1678           fi; \
1679         done; \
1680         test -z "$$error"
1681
1682 .PHONY: hs-tests
1683 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1684         @rm -f htest.tix
1685         ./test/hs/htest
1686
1687 .PHONY: hs-shell
1688 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1689         @rm -f hpc-htools.tix hpc-mon-collector.tix
1690         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1691
1692 .PHONY: hs-check
1693 hs-check: hs-tests hs-shell
1694
1695 # E111: indentation is not a multiple of four
1696 # E121: continuation line indentation is not a multiple of four
1697 #       (since our indent level is not 4)
1698 # E125: continuation line does not distinguish itself from next logical line
1699 #       (since our indent level is not 4)
1700 # E127: continuation line over-indented for visual indent
1701 #       (since our indent level is not 4)
1702 # note: do NOT add E128 here; it's a valid style error in most cases!
1703 # I've seen real errors, but also some cases were we indent wrongly
1704 # due to line length; try to rework the cases where it is triggered,
1705 # instead of silencing it
1706 # E261: at least two spaces before inline comment
1707 # E501: line too long (80 characters)
1708 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1709
1710 # For excluding pep8 expects filenames only, not whole paths
1711 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1712
1713 LINT_TARGETS = pylint pylint-qa
1714 if HAS_PEP8
1715 LINT_TARGETS += pep8
1716 endif
1717 if HAS_HLINT
1718 LINT_TARGETS += hlint
1719 endif
1720
1721 .PHONY: lint
1722 lint: $(LINT_TARGETS)
1723
1724 .PHONY: pylint
1725 pylint: $(GENERATED_FILES)
1726         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1727         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1728
1729 .PHONY: pylint-qa
1730 pylint-qa: $(GENERATED_FILES)
1731         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1732         cd $(top_srcdir)/qa && \
1733           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1734           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1735
1736 .PHONY: pep8
1737 pep8: $(GENERATED_FILES)
1738         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1739         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1740           --repeat $(pep8_python_code)
1741
1742 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1743 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1744 .PHONY: hlint
1745 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1746         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1747         @rm -f doc/hs-lint.html
1748         if tty -s; then C="-c"; else C=""; fi; \
1749         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1750           --ignore "Use first" \
1751           --ignore "Use &&&" \
1752           --ignore "Use void" \
1753           --ignore "Reduce duplication" \
1754           --hint src/lint-hints \
1755           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1756         @if [ ! -f doc/hs-lint.html ]; then \
1757           echo "All good" > doc/hs-lint.html; \
1758         fi
1759
1760 # a dist hook rule for updating the vcs-version file; this is
1761 # hardcoded due to where it needs to build the file...
1762 dist-hook:
1763         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1764         rm -f $(top_distdir)/vcs-version
1765         cp -p $(srcdir)/vcs-version $(top_distdir)
1766
1767 # a distcheck hook rule for catching revision control directories
1768 distcheck-hook:
1769         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1770           echo "Found revision control files in final archive." 1>&2; \
1771           exit 1; \
1772         fi
1773         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1774           echo "Found Python byte code in final archive." 1>&2; \
1775           exit 1; \
1776         fi
1777         if find $(top_distdir) -name '*~' | grep .; then \
1778           echo "Found backup files in final archive." 1>&2; \
1779           exit 1; \
1780         fi
1781 # Empty files or directories should not be distributed. They can cause
1782 # unnecessary warnings for packagers. Directories used by automake during
1783 # distcheck must be excluded.
1784         if find $(top_distdir) -empty -and -not \( \
1785             -path $(top_distdir)/_build -or \
1786             -path $(top_distdir)/_inst \) | grep .; then \
1787           echo "Found empty files or directories in final archive." 1>&2; \
1788           exit 1; \
1789         fi
1790         if test -n "$(BUILD_RELEASE)" && \
1791            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1792            echo "Found unreleased version in NEWS." >&2; \
1793            exit 1; \
1794         fi
1795         if test -e $(top_distdir)/doc/man-html; then \
1796           echo "Found documentation including man pages in final archive" >&2; \
1797           exit 1; \
1798         fi
1799
1800 # When building a release, stricter checks should be used
1801 distcheck-release dist-release: export BUILD_RELEASE = 1
1802 distcheck-release: distcheck
1803
1804 distrebuildcheck: dist
1805         set -e; \
1806         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1807         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1808         cd $$builddir; \
1809         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1810         cd $(distdir); \
1811         ./configure; \
1812         $(MAKE) maintainer-clean; \
1813         cp $(abs_srcdir)/vcs-version .; \
1814         ./configure; \
1815         $(MAKE) $(AM_MAKEFLAGS)
1816
1817 dist-release: dist
1818         set -e; \
1819         for i in $(DIST_ARCHIVES); do \
1820           echo -n "Checking $$i ... "; \
1821           autotools/check-tar < $$i; \
1822           echo OK; \
1823         done
1824
1825 install-exec-local:
1826         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1827           "$(DESTDIR)${localstatedir}/log/ganeti" \
1828           "$(DESTDIR)${localstatedir}/run/ganeti"
1829
1830 .PHONY: apidoc
1831 if WANT_HSAPIDOC
1832 apidoc: py-apidoc hs-apidoc
1833 else
1834 apidoc: py-apidoc
1835 endif
1836
1837 .PHONY: py-apidoc
1838 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1839         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1840         $(RUN_IN_TEMPDIR) epydoc -v \
1841           --conf $(CURDIR)/epydoc.conf \
1842           --output $(CURDIR)/$(APIDOC_PY_DIR)
1843
1844 .PHONY: hs-apidoc
1845 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1846
1847 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1848         @test -n "$(HSCOLOUR)" || \
1849             { echo 'HsColour' not found during configure; exit 1; }
1850         @test -n "$(HADDOCK)" || \
1851             { echo 'haddock' not found during configure; exit 1; }
1852         rm -rf $(APIDOC_HS_DIR)/*
1853         for i in $(ALL_APIDOC_HS_DIRS); do \
1854           @mkdir_p@ $$i; \
1855           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1856         done
1857         set -e ; \
1858         export LC_ALL=en_US.UTF-8; \
1859         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1860         if [ "$(HS_PARALLEL3)" ]; \
1861         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1862         fi; \
1863         if [ "$(HS_REGEX_PCRE)" ]; \
1864         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1865         fi; \
1866         for file in $(HS_LIBTESTBUILT_SRCS); do \
1867           f_nosrc=$${file##src/}; \
1868           f_notst=$${f_nosrc##test/hs/}; \
1869           f_html=$${f_notst%%.hs}.html; \
1870           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1871         done ; \
1872         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1873           -t ganeti -p src/haddock-prologue \
1874           --source-module="%{MODULE/.//}.html" \
1875           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1876           $$OPTGHC \
1877           $(HS_LIBTESTBUILT_SRCS)
1878
1879 .PHONY: TAGS
1880 TAGS: $(GENERATED_FILES)
1881         rm -f TAGS
1882         $(GHC) -e ":etags" -v0 \
1883           $(filter-out -O -Werror,$(HFLAGS)) \
1884           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1885           $(HS_LIBTEST_SRCS)
1886         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1887           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1888           -path './qa/*.py' | \
1889           etags -l python -a -
1890
1891 .PHONY: coverage
1892 if WANT_HTOOLS
1893 coverage: py-coverage hs-coverage
1894 else
1895 coverage: py-coverage
1896 endif
1897
1898 .PHONY: py-coverage
1899 py-coverage: $(GENERATED_FILES) $(python_tests)
1900         @test -n "$(PYCOVERAGE)" || \
1901             { echo 'python-coverage' not found during configure; exit 1; }
1902         set -e; \
1903         COVERAGE=$(PYCOVERAGE) \
1904         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1905         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1906         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1907         $(PLAIN_TESTS_ENVIRONMENT) \
1908         $(abs_top_srcdir)/autotools/gen-py-coverage \
1909         $(python_tests)
1910
1911 .PHONY: hs-coverage
1912 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1913         rm -f *.tix
1914         $(MAKE) $(AM_MAKEFLAGS) hs-check
1915         @mkdir_p@ $(COVERAGE_HS_DIR)
1916         hpc sum --union $(HPCEXCL) \
1917           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1918         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1919         hpc report coverage-hs.tix
1920         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1921
1922 # Special "kind-of-QA" target for htools, needs special setup (all
1923 # tools compiled with -fhpc)
1924 .PHONY: live-test
1925 live-test: all
1926         set -e ; \
1927         cd src; \
1928         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1929         rm -f *.tix *.mix; \
1930         ./live-test.sh; \
1931         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1932           --output=live-test.tix ; \
1933         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1934         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1935           --srcdir=.. $(HPCEXCL) ; \
1936         hpc report --srcdir=.. live-test $(HPCEXCL)
1937
1938 commit-check: distcheck lint apidoc
1939
1940 .PHONY: gitignore-check
1941 gitignore-check:
1942         @if [ -n "`git status --short`" ]; then \
1943           echo "Git status is not clean!" 1>&2 ; \
1944           git status --short; \
1945           exit 1; \
1946         fi
1947
1948 # target to rebuild all man pages (both groff and html output)
1949 .PHONY: man
1950 man: $(man_MANS) $(manhtml)
1951
1952 # Target that builds all binaries (including those that are not
1953 # rebuilt except when running the tests)
1954 .PHONY: really-all
1955 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1956
1957 # we don't need the ancient implicit rules:
1958 %: %,v
1959 %: RCS/%,v
1960 %: RCS/%
1961 %: s.%
1962 %: SCCS/s.%
1963
1964 -include ./Makefile.local
1965
1966 # vim: set noet :